<!DOCTYPE html>
<!--
    (c) Copyright 2020 CERN for the benefit of the LHCb Collaboration

    This software is distributed under the terms of the GNU General Public
    Licence version 3 (GPL Version 3), copied verbatim in the file "COPYING".

    In applying this licence, CERN does not waive the privileges and immunities
    granted to it by virtue of its status as an Intergovernmental Organization
    or submit itself to any jurisdiction.
-->
<html>
<head>
  <meta charset="utf-8"/>

  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/themes/prism.css" rel="stylesheet" />
  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/themes/prism-okaidia.css" rel="stylesheet" />
  {#- Plugins #}
  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/line-numbers/prism-line-numbers.css" rel="stylesheet" />
  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/toolbar/prism-toolbar.css" rel="stylesheet" />

  <link href="/static/analysis-productions.css" rel="stylesheet" />
  <script src="/static/analysis-productions.js"></script>

  <script type="text/javascript">
    document.addEventListener('DOMContentLoaded', function(event) {
      var heading = document.createElement('h2');
      document.body.appendChild(heading);

      const urlParams = new URLSearchParams(window.location.search);
      logURL = urlParams.get("logURL");
      if (logURL) {
        heading.textContent = "Loading requested URL...";
        fetch(logURL)
          .then(r => r.blob().then(data => data.text()).then(text => [r, text]))
          .then(([r, text]) => {
            console.log(r);
            if (!r.ok)
              throw new Error(text);

            var form = new FormData()
            var blob = new Blob([text], {type: 'text/plain'});
            form.append('file', blob)
            heading.textContent = "Generating explanations...";
            fetch('/explain-log/', {
              method: 'POST',
              body: form,
            }).then(r => r.json().then(data => [r, data]))
            .then(([r, data]) => {
              if (!r.ok)
                throw new Error(data['message']);

              // Create the explanation panel
              var explain_div = document.createElement('div');
              explain_div.id = 'job-log-explain';
              lbap_fill_log_explanation(explain_div, data.errors, 'Fatal errors:');
              lbap_fill_log_explanation(explain_div, data.suggestions, 'Suggestions:');
              lbap_fill_log_explanation(explain_div, data.explanations, 'Other explanations:');
              document.body.appendChild(explain_div);

              // Create the log display
              var log_div = document.createElement('div');
              var log_pre = document.createElement('pre');
              // log_pre.classList.add("line-numbers");
              var log_code = document.createElement('code');
              log_code.classList.add("language-gaudirunlog");
              log_code.textContent = text;
              log_code.setAttribute("data-toolbar-order", "log-filters,copy-to-clipboard,select-code")
              log_pre.appendChild(log_code);
              log_div.appendChild(log_pre);
              document.body.appendChild(log_div);
              Prism.highlightAll();

              heading.textContent = logURL;
            }).catch((error) => {
              console.error('Error:', error);
              throw error;
            })

          }).catch((error) => {
            console.error('Error:', error);
            alert('Failed to load: ' + error);
            heading.textContent = "Error";

            // Redirect to the main page
            var url = new URL(window.location);
            url.search = "";
            window.location = url;
          });
      } else {
        heading.textContent = "Enter a log URL:";
        var form = document.createElement('form');

        var url_box = document.createElement('input');
        url_box.style.width = "95%";
        form.appendChild(url_box);

        var submit_btn = document.createElement('input');
        submit_btn.type = "submit";
        submit_btn.value = "Load log";
        form.appendChild(submit_btn);

        form.onsubmit = function() {
          var url = new URL(window.location);
          url.search = null;
          url.searchParams.append("logURL", url_box.value);
          window.location = url;
          return false;
        };
        document.body.appendChild(form);
        // https://lhcb-dirac-logse.web.cern.ch/lhcb-dirac-logse/lhcb/MC/2018/LOG/00104988/0000/00000011/Gauss_00104988_00000011_1.log
      }
    })
  </script>
</head>
<body class="line-numbers" data-toolbar-order="log-filters,copy-to-clipboard,select-code,download-file">

<script src="https://cdnjs.cloudflare.com/ajax/libs/showdown/1.9.1/showdown.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/prism.js"></script>
{# Languages -#}
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/components/prism-bash.js"></script>
{# Plugins -#}
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/line-numbers/prism-line-numbers.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/toolbar/prism-toolbar.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.4/clipboard.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/copy-to-clipboard/prism-copy-to-clipboard.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/normalize-whitespace/prism-normalize-whitespace.js"></script>
{# Customisations -#}
<script src="/static/prism-gaudirunlog.js"></script>
<script src="/static/prism-toolbar.js"></script>
</body>
</html>
